#include "buffer.h"

#include <stdio.h>
#include <stdlib.h>

#include "err.h"

void init_buffer(buffer *b, int size, int incsize)
{
  b->data = malloc(size); if (!b->data) R;
  b->size = 0;
  b->maxsize = size;
  b->incsize = incsize;
}

void close_buffer(buffer *b)
{
  free(b->data);
}

void bchar(buffer *b, char c)
{
  if (b->size == b->maxsize) {
    b->maxsize += b->incsize;
    b->data = realloc(b->data, b->maxsize); if (!b->data) R;
  }
  b->data[b->size] = c;
  b->size++;
}

void bstring(buffer *b, char *s)
{
  while (*s) { bchar(b, *s); s++; }
}
