#ifndef _DICT_H_
#define _DICT_H_

#include "buffer.h"
#include "hash.h"

typedef struct {
  int count;
  int key;
  int *indoc;
  int maxsize;
  int size;
} word;

typedef struct {
  word *words;
  int total_words;
  int count;
  unsigned char isspace[256];
  unsigned char upper[256];
  buffer curword;
  hash h;
} dict;

void init_dict(dict *);
void close_dict(dict *);

void dict_populate(dict *, const unsigned char *);
void dict_word_to_doc(dict *, const unsigned char *, int);

#endif /* _DICT_H_ */
